//
//  ViewController.m
//  NSScannerTest
//
//  Created by Brian Prescott on 11/6/12.
//  Copyright (c) 2012 Wave 39 LLC. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

@synthesize theTextField, theTextView;

- (void)processHexString:(NSString *)hexString
{
    NSMutableString *s = [NSMutableString stringWithString:@"Hex string data:\n"];
    int theLength = [hexString length];
    if (theLength % 2 != 0)
    {
        theLength--;
    }
    
    for (int i = 0; i < theLength; i += 2)
    {
        NSRange theRange = NSMakeRange(i, 2);
        NSString *hexDigits = [hexString substringWithRange:theRange];
        unsigned int theValue;
        [[NSScanner scannerWithString:hexDigits] scanHexInt:&theValue];
        NSLog(@"Byte number %d is %d\n", (i / 2), theValue);
        [s appendFormat:@"Byte number %d is %d\n", (i / 2), theValue];
    }
    
    [theTextView setText:s];
}

- (void)readDataFromURL:(NSString *)urlString
{
    [theTextView setText:[NSString stringWithFormat:@"Please wait, attempting to contact %@", urlString]];
    
    NSURL *url = [NSURL URLWithString:urlString];
    NSURLRequest *req = [NSURLRequest requestWithURL:url];
    [NSURLConnection connectionWithRequest:req delegate:self];
}

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    theData = [[NSMutableData alloc] init];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    [theData appendData:data];
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
    [theTextView setText:[NSString stringWithFormat:@"Error: %@", [error localizedDescription]]];
}

- (void)connectionDidFinishLoading:(NSURLConnection *)conn
{
    if ([theData length] == 0)
    {
        return;
    }
    
    NSMutableString *s = [NSMutableString stringWithString:@"Links found:\n"];
    NSString *d = [NSString stringWithUTF8String:[theData bytes]];
    
    NSScanner *scanner = [NSScanner scannerWithString:d];
    NSString *foundString = nil;
    [scanner scanUpToString:@"a href=" intoString:nil];
    while (![scanner isAtEnd])
    {
        [scanner scanUpToString:@"\"" intoString:nil];
        scanner.scanLocation++;
        [scanner scanUpToString:@"\"" intoString:&foundString];
        [scanner scanUpToString:@"a href=" intoString:nil];
        NSLog(@"Link found: %@", foundString);
        [s appendFormat:@"%@\n", foundString];
    }
    
    [theTextView setText:s];
}

- (IBAction)runPressed:(id)sender
{
    [theTextField resignFirstResponder];
    
    NSString *theTextFieldString = theTextField.text;

    NSRegularExpression *regex = [NSRegularExpression regularExpressionWithPattern:@"^[0-9A-F]+$" options:NSRegularExpressionCaseInsensitive error:NULL];
    NSTextCheckingResult *matchesHexPattern = [regex firstMatchInString:theTextFieldString options:0 range:NSMakeRange(0, [theTextFieldString length])];
    if (matchesHexPattern)
    {
        [self processHexString:theTextFieldString];
    }
    else
    {
        if (![theTextFieldString hasPrefix:@"http"])
        {
            theTextFieldString = [NSString stringWithFormat:@"http://%@", theTextFieldString];
        }
        
        [self readDataFromURL:theTextFieldString];
    }
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
